package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.zhtml.Filedownload;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;

import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

@Controller("configLayoutImpressaoBoletoController")
@Scope("prototype")
public class ConfigLayoutImpressaoBoletoController extends MyGenericForwardComposer
		implements ListitemRenderer {

	private static final long serialVersionUID = 1L;
	private MyListbox campoCoordenadasList;
	private Combobox cmbCampo;
	private Intbox txtLinha;
	private Intbox txtColuna;
	private List<ConfigCoordenadas> lsConfigCoordenadas;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		lsConfigCoordenadas = new ArrayList<ConfigCoordenadas>();

		campoCoordenadasList.setItemRenderer(this);
	}

	public void onClick$btnSalvar(Event ev) throws IOException {

		StringBuilder txt = new StringBuilder();
		for (ConfigCoordenadas c : lsConfigCoordenadas) {
			txt.append(c.getCampo()).append(".linha=").append(c.getLinha()).append("\n");
			txt.append(c.getCampo()).append(".coluna=").append(c.getColuna()).append("\n");
		}

		String nomeArquivo = "coordenadas.properties";

		FileOutputStream stream = new FileOutputStream(nomeArquivo);
		stream.flush();
		stream.write(txt.toString().getBytes());
		stream.close();

		InputStream is = new FileInputStream(nomeArquivo);
		Filedownload.save(is, "application/properties", nomeArquivo);
	}

	public void onClick$btnAddCampoCoordenadas(Event ev) {
		String campo = "VAZIO";
		String lbCampo = cmbCampo.getText();
		Comboitem cbiCampo = cmbCampo.getSelectedItem();
		if (cbiCampo != null) {
			campo = (String) cbiCampo.getValue();
		}

		Integer linha = txtLinha.getValue();
		Integer coluna = txtColuna.getValue();

		ConfigCoordenadas configCoordenadas = new ConfigCoordenadas();
		configCoordenadas.setLbCampo(lbCampo);
		configCoordenadas.setCampo(campo);
		configCoordenadas.setLinha(linha);
		configCoordenadas.setColuna(coluna);

		if ((!campo.equals("VAZIO")) && (linha != null) && (coluna != null)) {
			if (!lsConfigCoordenadas.contains(configCoordenadas)) {
				lsConfigCoordenadas.add(configCoordenadas);

				campoCoordenadasList.setData(lsConfigCoordenadas);

				cmbCampo.setSelectedItem(null);
				txtLinha.setValue(null);
				txtColuna.setValue(null);
			}
		}
	}

	public void onClick$btnRemoverCampoCoordenadas(Event ev) {
		ConfigCoordenadas configCoordenadas = (ConfigCoordenadas) campoCoordenadasList.getSelected();

		lsConfigCoordenadas.remove(configCoordenadas);

		campoCoordenadasList.setData(lsConfigCoordenadas);
	}

	@Override
	public void render(Listitem lstm, Object o) throws Exception {
		ConfigCoordenadas configCoordenadas = (ConfigCoordenadas) o;

		Listcell lc = new Listcell();

		lc = new Listcell(configCoordenadas.getLbCampo());
		lc.setParent(lstm);

		lc = new Listcell(configCoordenadas.getLinha().toString());
		lc.setParent(lstm);

		lc = new Listcell(configCoordenadas.getColuna().toString());
		lc.setParent(lstm);

		lstm.setAttribute("data", configCoordenadas);
	}

	class ConfigCoordenadas {
		private String lbCampo;
		private String campo;
		private Integer linha;
		private Integer coluna;

		public ConfigCoordenadas() {
			super();
		}

		public String getLbCampo() {
			return lbCampo;
		}

		public void setLbCampo(String lbCampo) {
			this.lbCampo = lbCampo;
		}

		public String getCampo() {
			return campo;
		}

		public void setCampo(String campo) {
			this.campo = campo;
		}

		public Integer getLinha() {
			return linha;
		}

		public void setLinha(Integer linha) {
			this.linha = linha;
		}

		public Integer getColuna() {
			return coluna;
		}

		public void setColuna(Integer coluna) {
			this.coluna = coluna;
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + getOuterType().hashCode();
			result = prime * result + ((campo == null) ? 0 : campo.hashCode());
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			ConfigCoordenadas other = (ConfigCoordenadas) obj;
			if (!getOuterType().equals(other.getOuterType()))
				return false;
			if (campo == null) {
				if (other.campo != null)
					return false;
			} else if (!campo.equals(other.campo))
				return false;
			return true;
		}

		private ConfigLayoutImpressaoBoletoController getOuterType() {
			return ConfigLayoutImpressaoBoletoController.this;
		}
	}
}
